#!/bin/bash
#
# Copyright (c) 2010, Benjamin C. Meyer <ben@meyerhome.net>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. Neither the name of the project nor the
#    names of its contributors may be used to endorse or promote products
#    derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER ''AS IS'' AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

dir=`dirname $0`

function test_file {
    file="${1}"
    QMAKE=qmake
    $QMAKE --version 2>&1 | grep 3.3 > /dev/null
    if [ $? -eq 0 ] ; then
        QMAKE=qmake-qt4
    fi
    unset GIT_DIR
    file=`echo $file | sed -e 's/src\///g' -e 's/.cpp//g'`
    autotest=`echo $file | sed -e 's/.*\///g'`
    if [ ! -d $dir/../autotests/$file ] ; then
        file=$autotest;
    fi
    if [ -d $dir/../autotests/$file ] ; then
        echo "--checking autotest: $file--"

        tempfoo=`basename $0`
        TMPFILE=`mktemp -t ${tempfoo}.XXXXXXXXXX` || exit 1
        (cd "$dir/../../autotests/$file/"; $QMAKE; make --quiet $MAKE_FLAGS; ./$autotest >> $TMPFILE)
        output=`cat $TMPFILE | grep ' failed,' | sed -e 's/.*passed, //g' -e 's/ failed.*//g'`
        if [ "${output}" != "0" ] ; then
            echo "Autotests failed for $file, please fix before committing."
            cat $TMPFILE
            rm $TMPFILE
            exit 1
        fi
        rm $TMPFILE
        echo "--checking autotest: $file done--"
    else
        echo "--missing autotest: $file--"
    fi
}

case "${1}" in
    --about )
        echo "Check that existing autotests for files that are being commited are not currently failing."
        ;;
    * )
        for file in `git diff-index --cached --name-only HEAD | grep .cpp` ; do
            test_file "${file}"
        done
        ;;
esac
